--- old/usr/src/cmd/sgs/prof/common/prof.c	Tue Feb 27 22:54:11 2018
+++ new/usr/src/cmd/sgs/prof/common/prof.c	Tue Feb 27 22:54:11 2018
@@ -22,6 +22,7 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2018 Jason King
  */
 
 /*	Copyright (c) 1988 AT&T	*/
@@ -1311,9 +1312,7 @@
 	const char *name;
 	size_t	len;
 
-	name = conv_demangle_name(s);
-
-	if (strcmp(name, s) == 0)
+	if ((name = conv_demangle_name(s)) == s)
 		return (s);
 
 	if (format_buf != NULL)
@@ -1324,6 +1323,7 @@
 	if (format_buf == NULL)
 		return (s);
 	(void) snprintf(format_buf, len, FORMAT_BUF, name, s);
+	free((void *)name);
 	return (format_buf);
 }
 
